diff --git a/chrome/browser/ui/views/extensions/extension_action_prompt_view.h b/chrome/browser/ui/views/extensions/extension_action_prompt_view.h
new file mode 100644
index 000000000000..d5c5c043095e
--- /dev/null
+++ b/chrome/browser/ui/views/extensions/extension_action_prompt_view.h
@@ -0,0 +1,120 @@
+// Copyright 2014 The Chromium Authors. All rights reserved.
+// Use of this source code is governed by a BSD-style license that can be
+// found in the LICENSE file.
+
+#ifndef CHROME_BROWSER_UI_VIEWS_EXTENSIONS_EXTENSION_ACTION_PROMPT_VIEW_H_
+#define CHROME_BROWSER_UI_VIEWS_EXTENSIONS_EXTENSION_ACTION_PROMPT_VIEW_H_
+
+#include <map>
+
+#include "base/macros.h"
+#include "ui/views/view.h"
+#include "ui/views/window/dialog_delegate.h"
+#include "ui/views/window/dialog_client_view.h"
+
+#include "base/memory/weak_ptr.h"
+#include "chrome/browser/ui/views/extensions/suspicious_action_config.h"
+#include "base/logging.h"
+#include "base/macros.h"
+#include "base/memory/ref_counted.h"
+#include "content/public/browser/notification_observer.h"
+#include "content/public/browser/notification_registrar.h"
+#include "ui/gfx/native_widget_types.h"
+#include "ui/views/window/dialog_delegate.h"
+#include "content/public/browser/web_contents_delegate.h"
+#include "extensions/common/extension.h"
+#include "content/public/browser/web_contents.h"
+#include "chrome/browser/profiles/profile.h"
+#include "ui/views/controls/button/checkbox.h"
+
+class ExtensionActionPromptView : public views::DialogDelegateView,
+                                  public views::ButtonListener {
+  public:
+    static void ShowDialog(content::WebContents* source,
+                           gfx::NativeWindow parent_window,
+                           const base::string16& message,
+                           const SuspiciousExtensionAction& extension_action,
+                           const SensitiveElement& sensitive_element,
+                           const GURL& frame_url,
+                           const GURL& extension_url,
+                           const content::WebContentsDelegate::DialogClosedCallback& callback);
+
+
+  private:
+    ExtensionActionPromptView(gfx::NativeWindow parent_window,
+                              const base::string16& message,
+                              const SensitiveElement& sensitive_element,
+                              const GURL& frame_url,
+                              const content::WebContentsDelegate::DialogClosedCallback& callback,
+                              const extensions::Extension* extension,
+                              const gfx::Image& image,
+                              bool should_show_dialog);
+
+    ~ExtensionActionPromptView() override;
+
+    static void ShowDialogWithImage(content::WebContents* source,
+                                    gfx::NativeWindow parent_window,
+                                    const base::string16& message,
+                                    const SuspiciousExtensionAction& extension_action,
+                                    const SensitiveElement& sensitive_element,
+                                    const GURL& frame_url,
+                                    const content::WebContentsDelegate::DialogClosedCallback& callback,
+                                    const extensions::Extension* extension,
+                                    const gfx::Image& image);
+
+    static void ShouldShowDialogWithImage(content::WebContents* source,
+                                          gfx::NativeWindow parent_window,
+                                          const base::string16& message,
+                                          const SensitiveElement& sensitive_element,
+                                          const GURL& frame_url,
+                                          const content::WebContentsDelegate::DialogClosedCallback& callback,
+                                          const extensions::Extension* extension,
+                                          const gfx::Image& image,
+                                          bool should_show_dialog);
+
+    enum class RememberPreference {
+      DONT_REMEMBER,
+      ALWAYS_PREVENT,
+      ALWAYS_ALLOW,
+      ALWAYS_ALLOW_IF_NOT_SENSITIVE,
+    };
+
+    std::map<base::string16, RememberPreference>& Cache() {
+        static std::map<base::string16, RememberPreference> &cache =
+          *new std::map<base::string16, RememberPreference>;
+        return cache;
+    }
+
+    void InitDialog();
+
+    bool Cancel() override;
+    bool Close() override;
+    bool Accept() override;
+    base::string16 GetDialogButtonLabel(ui::DialogButton button) const override;
+    bool ShouldShowWindowTitle() const override;
+    base::string16 GetWindowTitle() const override;
+    bool ShouldDefaultButtonBeBlue() const override;
+    views::View* CreateExtraView() override;
+    ui::ModalType GetModalType() const override;
+    // views::ButtonListener:
+    // This is called when the only_sensitive_checkbox_ is clicked.
+    void ButtonPressed(views::Button* sender, const ui::Event& event) override;
+
+    const base::string16& message_;
+    const GURL& frame_url_;
+    content::WebContentsDelegate::DialogClosedCallback callback_;
+    gfx::NativeWindow parent_window_;
+    const extensions::Extension* extension_;
+
+    const SensitiveElement& sensitive_element_;
+
+    views::Checkbox* always_allow_non_sensitive_checkbox_;
+    views::Checkbox* always_allow_checkbox_;
+    views::Checkbox* always_prevent_checkbox_;
+
+    base::string16 key_;
+
+    DISALLOW_COPY_AND_ASSIGN(ExtensionActionPromptView);
+};
+
+#endif  // CHROME_BROWSER_UI_VIEWS_EXTENSIONS_EXTENSION_ACTION_PROMPT_VIEW_H_
diff --git a/chrome/browser/ui/views/extensions/extension_suspicious_actions_view.cc b/chrome/browser/ui/views/extensions/extension_suspicious_actions_view.cc
new file mode 100644
index 000000000000..87681fc7c119
--- /dev/null
+++ b/chrome/browser/ui/views/extensions/extension_suspicious_actions_view.cc
@@ -0,0 +1,316 @@
+// Copyright (c) 2012 The Chromium Authors. All rights reserved.
+// Use of this source code is governed by a BSD-style license that can be
+// found in the LICENSE file.
+
+#include "chrome/browser/ui/views/extensions/extension_suspicious_actions_view.h"
+
+#include <stddef.h>
+#include <algorithm>
+#include <string>
+#include <utility>
+#include <vector>
+
+#include "base/memory/weak_ptr.h"
+#include "base/callback_helpers.h"
+#include "base/callback.h"
+#include "base/command_line.h"
+#include "base/compiler_specific.h"
+#include "base/i18n/rtl.h"
+#include "base/macros.h"
+#include "base/metrics/histogram_macros.h"
+#include "base/strings/string_util.h"
+#include "base/strings/utf_string_conversions.h"
+#include "chrome/app/vector_icons/vector_icons.h"
+#include "chrome/browser/browser_process.h"
+#include "chrome/browser/extensions/api/experience_sampling_private/experience_sampling.h"
+#include "chrome/browser/extensions/extension_install_prompt_show_params.h"
+#include "chrome/browser/profiles/profile.h"
+#include "chrome/browser/ui/browser.h"
+#include "chrome/browser/ui/scoped_tabbed_browser_displayer.h"
+#include "chrome/common/extensions/extension_constants.h"
+#include "chrome/grit/generated_resources.h"
+#include "chrome/installer/util/browser_distribution.h"
+#include "components/constrained_window/constrained_window_views.h"
+#include "content/public/browser/browser_thread.h"
+#include "content/public/browser/page_navigator.h"
+#include "content/public/browser/web_contents.h"
+#include "extensions/common/extension.h"
+#include "extensions/common/extension_urls.h"
+#include "ui/base/l10n/l10n_util.h"
+#include "ui/views/controls/button/checkbox.h"
+#include "ui/base/resource/resource_bundle.h"
+#include "ui/gfx/color_palette.h"
+#include "ui/gfx/paint_vector_icon.h"
+#include "ui/gfx/text_utils.h"
+#include "ui/native_theme/common_theme.h"
+#include "ui/views/border.h"
+#include "ui/views/controls/button/image_button.h"
+#include "ui/views/controls/image_view.h"
+#include "ui/views/controls/label.h"
+#include "ui/views/controls/link.h"
+#include "ui/views/controls/scroll_view.h"
+#include "ui/views/controls/separator.h"
+#include "ui/views/layout/box_layout.h"
+#include "ui/views/layout/grid_layout.h"
+#include "ui/views/layout/layout_constants.h"
+#include "ui/views/widget/widget.h"
+#include "ui/base/ui_base_types.h"
+#include "ui/gfx/font_list.h"
+#include "components/url_formatter/elide_url.h"
+#include "content/public/browser/web_contents.h"
+#include "base/strings/string_piece.h"
+#include "url/gurl.h"
+#include "extensions/common/extension_set.h"
+#include "extensions/browser/extension_registry.h"
+#include "extensions/common/constants.h"
+#include "extensions/common/manifest_handlers/icons_handler.h"
+#include "extensions/browser/image_loader.h"
+#include "base/bind.h"
+#include "chrome/browser/extensions/extension_util.h"
+#include "extensions/browser/state_store.h"
+#include "chrome/browser/extensions/extension_system_impl.h"
+#include "extensions/browser/state_store.h"
+
+namespace {
+  const int kRightColumnWidth = 300;
+  const int kIconSize = 64;
+
+  // Returns gfx::ImageSkia for the default icon.
+  gfx::ImageSkia GetDefaultIconImage(bool is_app) {
+    return  is_app ? extensions::util::GetDefaultAppIcon() : extensions::util::GetDefaultExtensionIcon();
+  }
+}
+
+ExtensionSuspiciousActionsView::ExtensionSuspiciousActionsView(
+    const DialogClosedCallback& callback,
+    content::BrowserContext* browser_context,
+    Profile* profile,
+    content::WebContents* source,
+    const extensions::Extension* extension,
+    const gfx::Image& image)
+  : callback_(callback),
+    extension_(extension) {
+
+  suspicious_action_config_ = new SuspiciousActionConfig(browser_context);
+
+  SetLayoutManager(new views::BoxLayout(views::BoxLayout::kVertical, 0, 0, 0));
+
+  views::View* top = new views::View();
+  top->SetLayoutManager(new views::BoxLayout(
+    views::BoxLayout::kHorizontal, views::kButtonHEdgeMarginNew,
+    views::kPanelVertMargin, views::kRelatedControlHorizontalSpacing
+  ));
+
+  gfx::ImageSkia icon;
+  if (image.IsEmpty()) {
+    icon = GetDefaultIconImage(extension_->is_app());
+  } else {
+    icon = *image.ToImageSkia();
+  }
+
+  views::ImageView* iconView = new views::ImageView();
+  DCHECK_GE(icon.width(), kIconSize);
+  DCHECK_GE(icon.height(), kIconSize);
+  iconView->SetImageSize(gfx::Size(kIconSize, kIconSize));
+  iconView->SetImage(icon);
+  top->AddChildView(iconView);
+
+  views::Label* heading_ = new views::Label(
+    base::ASCIIToUTF16("Chromium intercepts and prompts users to allow or prevent certain extension actions that it considers suspicious. You can optionally configure these actions below for the \"") +
+    base::UTF8ToUTF16(extension_->name()) +
+    base::ASCIIToUTF16("\" extension.\n")
+  );
+  heading_->SetMultiLine(true);
+  heading_->SetHorizontalAlignment(gfx::ALIGN_LEFT);
+  heading_->SetAllowCharacterBreak(true);
+  heading_->SizeToFit(kRightColumnWidth);
+  top->AddChildView(heading_);
+
+  AddChildView(top);
+
+  views::View* bottom = new views::View();
+  bottom->SetLayoutManager(new views::BoxLayout(
+    views::BoxLayout::kVertical, views::kButtonHEdgeMarginNew,
+    0, 0
+  ));
+
+  views::Label* label_ = new views::Label(
+    base::ASCIIToUTF16("Chromium will your ask permission before the extension:\n")
+  );
+  label_->SetFontList(label_->font_list().DeriveWithWeight(gfx::Font::Weight::BOLD));
+
+  label_->SetMultiLine(true);
+  label_->SetHorizontalAlignment(gfx::ALIGN_LEFT);
+  label_->SizeToFit(kRightColumnWidth);
+  bottom->AddChildView(label_);
+
+  event_ = new views::Checkbox(base::ASCIIToUTF16("Fires an event"));
+  InitCheckbox(event_);
+  bottom->AddChildView(event_);
+
+  network_ = new views::Checkbox(base::ASCIIToUTF16("Sends a network request"));
+  InitCheckbox(network_);
+  bottom->AddChildView(network_);
+
+  dom_ = new views::Checkbox(base::ASCIIToUTF16("Adds, removes or replaces an element"));
+  InitCheckbox(dom_);
+  bottom->AddChildView(dom_);
+
+  description_ = new views::Checkbox(base::ASCIIToUTF16("Changes an element's description"));
+  InitCheckbox(description_);
+  bottom->AddChildView(description_);
+
+  reads_ = new views::Checkbox(base::ASCIIToUTF16("Reads data from an element"));
+  InitCheckbox(reads_);
+  bottom->AddChildView(reads_);
+
+  changes_ = new views::Checkbox(base::ASCIIToUTF16("Changes an element's data"));
+  InitCheckbox(changes_);
+  bottom->AddChildView(changes_);
+
+  create_ = new views::Checkbox(base::ASCIIToUTF16("Creates (but does not add) an element"));
+  InitCheckbox(create_);
+  bottom->AddChildView(create_);
+
+  receive_ = new views::Checkbox(base::ASCIIToUTF16("Receives a network response"));
+  InitCheckbox(receive_);
+  bottom->AddChildView(receive_);
+
+  AddChildView(bottom);
+
+  constrained_window::CreateWebModalDialogViews(this, source)->Show();
+}
+
+void ExtensionSuspiciousActionsView::ShowDialogWithImage(
+    const DialogClosedCallback& callback,
+    content::BrowserContext* browser_context,
+    Profile* profile,
+    content::WebContents* source,
+    const extensions::Extension* extension,
+    const gfx::Image& image) {
+   new ExtensionSuspiciousActionsView(
+     callback,
+     browser_context,
+     profile,
+     source,
+     extension,
+     image
+   );
+}
+
+void ExtensionSuspiciousActionsView::ShowDialog(
+    const DialogClosedCallback& callback,
+    content::BrowserContext* browser_context,
+    Profile* profile,
+    content::WebContents* source,
+    const extensions::Extension* extension) {
+
+   // Bookmark apps may not have 128x128 icons so accept 64x64 icons.
+   const int icon_size = extension->from_bookmark()
+                             ? extension_misc::EXTENSION_ICON_SMALL * 2
+                             : extension_misc::EXTENSION_ICON_LARGE;
+   extensions::ExtensionResource image = extensions::IconsInfo::GetIconResource(
+       extension, icon_size, ExtensionIconSet::MATCH_BIGGER);
+
+   // Load the image asynchronously. The response will be sent to OnImageLoaded.
+   extensions::ImageLoader* loader = extensions::ImageLoader::Get(source->GetBrowserContext());
+
+   std::vector<extensions::ImageLoader::ImageRepresentation> images_list;
+   images_list.push_back(extensions::ImageLoader::ImageRepresentation(
+       image,
+       extensions::ImageLoader::ImageRepresentation::NEVER_RESIZE,
+       gfx::Size(),
+       ui::SCALE_FACTOR_100P));
+   loader->LoadImagesAsync(
+     extension, images_list,
+     base::Bind(&ExtensionSuspiciousActionsView::ShowDialogWithImage,
+                callback, browser_context, profile, source, extension)
+   );
+}
+
+ExtensionSuspiciousActionsView::~ExtensionSuspiciousActionsView() {
+  ExtensionSuspiciousActionsView::Cancel();
+}
+
+int ExtensionSuspiciousActionsView::GetDialogButtons() const {
+  return ui::DIALOG_BUTTON_CANCEL;
+}
+
+base::string16 ExtensionSuspiciousActionsView::GetDialogButtonLabel(ui::DialogButton button) const {
+  switch (button) {
+    case ui::DIALOG_BUTTON_CANCEL:
+      return base::ASCIIToUTF16("Close");
+    default:
+      NOTREACHED();
+      return base::string16();
+  }
+}
+
+bool ExtensionSuspiciousActionsView::Cancel() {
+  if (!callback_.is_null()) {
+    base::ResetAndReturn(&callback_).Run();
+  }
+  return true;
+}
+
+bool ExtensionSuspiciousActionsView::Close() {
+  if (!callback_.is_null()) {
+    callback_.Run();
+  }
+  return true;
+}
+
+ui::ModalType ExtensionSuspiciousActionsView::GetModalType() const {
+  return ui::ModalType::MODAL_TYPE_CHILD;
+}
+
+bool ExtensionSuspiciousActionsView::ShouldShowWindowTitle() const {
+  return true;
+}
+
+base::string16 ExtensionSuspiciousActionsView::GetWindowTitle() const {
+  return base::ASCIIToUTF16("Configure Suspicious Actions");
+}
+
+void ExtensionSuspiciousActionsView::ButtonPressed(views::Button* sender,
+                                                   const ui::Event& event) {
+  views::Checkbox* checkbox = (views::Checkbox*) sender;
+  suspicious_action_config_->SetActionSuspicious(
+    extension_->id(),
+    GetExtensionActionForCheckbox(checkbox),
+    checkbox->checked()
+  );
+}
+
+SuspiciousExtensionAction ExtensionSuspiciousActionsView::GetExtensionActionForCheckbox(views::Checkbox* checkbox) {
+  if (checkbox == event_) {
+    return SuspiciousExtensionAction::EVENT;
+  } else if (checkbox == network_) {
+    return SuspiciousExtensionAction::NETWORK_REQUEST;
+  } else if (checkbox == dom_) {
+    return  SuspiciousExtensionAction::DOM_MUTATION;
+  } else if (checkbox == description_) {
+    return SuspiciousExtensionAction::ELEMENT_DESCRIPTION_MUTATION;
+  } else if (checkbox == receive_) {
+    return SuspiciousExtensionAction::NETWORK_RESPONSE;
+  } else if (checkbox == create_) {
+    return SuspiciousExtensionAction::CREATE_ELEMENT;
+  } else if (checkbox == changes_) {
+    return SuspiciousExtensionAction::ELEMENT_MUTATION;
+  } else if (checkbox == reads_) {
+    return SuspiciousExtensionAction::READ_ELEMENT;
+  } else {
+    // Shouldn't get here...
+    return SuspiciousExtensionAction::EVENT;
+  }
+}
+
+void ExtensionSuspiciousActionsView::InitCheckbox(views::Checkbox* checkbox) {
+  checkbox->set_listener(this);
+  SuspiciousExtensionAction action = GetExtensionActionForCheckbox(checkbox);
+  suspicious_action_config_->IsActionSuspicious(
+    extension_->id(),
+    action,
+    base::Bind(&views::Checkbox::SetChecked, base::Unretained(checkbox))
+  );
+}
diff --git a/chrome/browser/ui/views/extensions/extension_suspicious_actions_view.h b/chrome/browser/ui/views/extensions/extension_suspicious_actions_view.h
new file mode 100644
index 000000000000..8daac71b26d4
--- /dev/null
+++ b/chrome/browser/ui/views/extensions/extension_suspicious_actions_view.h
@@ -0,0 +1,96 @@
+// Copyright 2014 The Chromium Authors. All rights reserved.
+// Use of this source code is governed by a BSD-style license that can be
+// found in the LICENSE file.
+
+#ifndef CHROME_BROWSER_UI_VIEWS_EXTENSIONS_EXTENSION_SUSPICIOUS_ACTIONS_VIEW_H_
+#define CHROME_BROWSER_UI_VIEWS_EXTENSIONS_EXTENSION_SUSPICIOUS_ACTIONS_VIEW_H_
+
+#include <map>
+
+#include "base/macros.h"
+#include "ui/views/view.h"
+#include "ui/views/window/dialog_delegate.h"
+#include "ui/views/window/dialog_client_view.h"
+
+#include "base/memory/weak_ptr.h"
+#include "base/logging.h"
+#include "base/macros.h"
+#include "base/memory/ref_counted.h"
+#include "content/public/browser/notification_observer.h"
+#include "content/public/browser/notification_registrar.h"
+#include "ui/gfx/native_widget_types.h"
+#include "ui/views/window/dialog_delegate.h"
+#include "content/public/browser/web_contents_delegate.h"
+#include "extensions/common/extension.h"
+#include "content/public/browser/web_contents.h"
+#include "chrome/browser/profiles/profile.h"
+#include "ui/views/controls/button/checkbox.h"
+#include "extensions/browser/state_store.h"
+#include "chrome/browser/ui/views/extensions/suspicious_action_config.h"
+
+typedef base::Callback<void()> DialogClosedCallback;
+
+class ExtensionSuspiciousActionsView : public views::DialogDelegateView,
+                                       public views::ButtonListener {
+  public:
+    ExtensionSuspiciousActionsView(const DialogClosedCallback& callback,
+                                   content::BrowserContext* browser_context,
+                                   Profile* profile,
+                                   content::WebContents* source,
+                                   const extensions::Extension* extension,
+                                   const gfx::Image& image);
+
+    ~ExtensionSuspiciousActionsView() override;
+
+    static void ShowDialog(const DialogClosedCallback& callback,
+                           content::BrowserContext* browser_context,
+                           Profile* profile,
+                           content::WebContents* source,
+                           const extensions::Extension* extension);
+
+    static void ShowDialogWithImage(const DialogClosedCallback& callback,
+                                    content::BrowserContext* browser_context,
+                                    Profile* profile,
+                                    content::WebContents* source,
+                                    const extensions::Extension* extension,
+                                    const gfx::Image& image);
+
+  private:
+    void InitDialog();
+
+    bool Cancel() override;
+    bool Close() override;
+    bool ShouldShowWindowTitle() const override;
+    base::string16 GetWindowTitle() const override;
+    ui::ModalType GetModalType() const override;
+    // views::ButtonListener:
+    // This is called when the only_sensitive_checkbox_ is clicked.
+    void ButtonPressed(views::Button* sender, const ui::Event& event) override;
+    int GetDialogButtons() const override;
+    base::string16 GetDialogButtonLabel(ui::DialogButton button) const override;
+
+    void GetExtensionValueCallback(
+      views::Checkbox* checkbox,
+      std::string key,
+      std::unique_ptr<base::Value> value
+    );
+    SuspiciousExtensionAction GetExtensionActionForCheckbox(views::Checkbox*);
+    void InitCheckbox(views::Checkbox* checkbox);
+
+    DialogClosedCallback callback_;
+    const extensions::Extension* extension_;
+    SuspiciousActionConfig* suspicious_action_config_;
+
+    views::Checkbox* event_;
+    views::Checkbox* network_;
+    views::Checkbox* dom_;
+    views::Checkbox* description_;
+    views::Checkbox* receive_;
+    views::Checkbox* reads_;
+    views::Checkbox* changes_;
+    views::Checkbox* create_;
+
+    DISALLOW_COPY_AND_ASSIGN(ExtensionSuspiciousActionsView);
+};
+
+#endif  // CHROME_BROWSER_UI_VIEWS_EXTENSIONS_EXTENSION_SUSPICIOUS_ACTIONS_VIEW_H_
diff --git a/chrome/browser/ui/views/extensions/suspicious_action_config.cc b/chrome/browser/ui/views/extensions/suspicious_action_config.cc
new file mode 100644
index 000000000000..071cb3b52bb4
--- /dev/null
+++ b/chrome/browser/ui/views/extensions/suspicious_action_config.cc
@@ -0,0 +1,171 @@
+// Copyright 2014 The Chromium Authors. All rights reserved.
+// Use of this source code is governed by a BSD-style license that can be
+// found in the LICENSE file.
+
+#include <map>
+#include <stddef.h>
+#include <algorithm>
+#include <string>
+#include <utility>
+#include <vector>
+
+#include "suspicious_action_config.h"
+
+#include "base/memory/weak_ptr.h"
+#include "base/callback_helpers.h"
+#include "base/callback.h"
+#include "base/command_line.h"
+#include "base/compiler_specific.h"
+#include "base/i18n/rtl.h"
+#include "base/macros.h"
+#include "base/metrics/histogram_macros.h"
+#include "base/strings/string_util.h"
+#include "base/strings/utf_string_conversions.h"
+#include "chrome/app/vector_icons/vector_icons.h"
+#include "chrome/browser/browser_process.h"
+#include "chrome/browser/extensions/api/experience_sampling_private/experience_sampling.h"
+#include "chrome/browser/extensions/extension_install_prompt_show_params.h"
+#include "chrome/browser/profiles/profile.h"
+#include "chrome/browser/ui/browser.h"
+#include "chrome/browser/ui/scoped_tabbed_browser_displayer.h"
+#include "chrome/common/extensions/extension_constants.h"
+#include "chrome/grit/generated_resources.h"
+#include "chrome/installer/util/browser_distribution.h"
+#include "components/constrained_window/constrained_window_views.h"
+#include "content/public/browser/browser_thread.h"
+#include "content/public/browser/page_navigator.h"
+#include "content/public/browser/web_contents.h"
+#include "extensions/common/extension.h"
+#include "extensions/common/extension_urls.h"
+#include "ui/base/l10n/l10n_util.h"
+#include "ui/views/controls/button/checkbox.h"
+#include "ui/base/resource/resource_bundle.h"
+#include "ui/gfx/color_palette.h"
+#include "ui/gfx/paint_vector_icon.h"
+#include "ui/gfx/text_utils.h"
+#include "ui/native_theme/common_theme.h"
+#include "ui/views/border.h"
+#include "ui/views/controls/button/image_button.h"
+#include "ui/views/controls/image_view.h"
+#include "ui/views/controls/label.h"
+#include "ui/views/controls/link.h"
+#include "ui/views/controls/scroll_view.h"
+#include "ui/views/controls/separator.h"
+#include "ui/views/layout/box_layout.h"
+#include "ui/views/layout/grid_layout.h"
+#include "ui/views/layout/layout_constants.h"
+#include "ui/views/widget/widget.h"
+#include "ui/base/ui_base_types.h"
+#include "ui/gfx/font_list.h"
+#include "components/url_formatter/elide_url.h"
+#include "content/public/browser/web_contents.h"
+#include "base/strings/string_piece.h"
+#include "url/gurl.h"
+#include "extensions/common/extension_set.h"
+#include "extensions/browser/extension_registry.h"
+#include "extensions/common/constants.h"
+#include "extensions/common/manifest_handlers/icons_handler.h"
+#include "extensions/browser/image_loader.h"
+#include "base/bind.h"
+#include "chrome/browser/extensions/extension_util.h"
+#include "extensions/browser/state_store.h"
+#include "chrome/browser/extensions/extension_system_impl.h"
+#include "extensions/browser/state_store.h"
+
+namespace {
+
+const char kPromptEvent[] = "prompt_event_fire";
+const char kPromptNetworkRequest[] = "prompt_network_request";
+const char kPromptDomMutation[] = "prompt_dom_mutation";
+const char kPromptElementDescriptionMutation[] = "prompt_description_mutation";
+const char kPromptNetworkResponse[] = "prompt_network_response";
+const char kPromptCreateElement[] = "prompt_create_element";
+const char kPromptReadElement[] = "prompt_read_element"; // just attributes
+const char kPromptElementMutation[] = "prompt_change_element"; // just attributes
+
+}
+
+void SuspiciousActionConfig::IsActionSuspicious(
+  const std::string& extension_id,
+  SuspiciousExtensionAction action,
+  const IsActionSuspiciousCallback& callback) {
+    const char* key = ExtensionActionToString(action);
+    state_store_->RegisterKey(key);
+    state_store_->GetExtensionValue(
+      extension_id,
+      key,
+      base::Bind(
+        &SuspiciousActionConfig::IsActionSuspiciousReadCallBack,
+        base::Unretained(this), extension_id, action, callback
+      )
+    );
+}
+
+void SuspiciousActionConfig::SetActionSuspicious(
+  const std::string& extension_id,
+  SuspiciousExtensionAction action,
+  bool is_suspicious) {
+    state_store_->SetExtensionValue(
+      extension_id,
+      ExtensionActionToString(action),
+      std::unique_ptr<base::Value>(new base::Value(is_suspicious))
+    );
+}
+
+void SuspiciousActionConfig::IsActionSuspiciousReadCallBack(
+  const std::string& extension_id,
+  SuspiciousExtensionAction action,
+  const IsActionSuspiciousCallback& callback,
+  std::unique_ptr<base::Value> value) {
+    if (value) {
+      callback.Run(value->GetBool());
+    } else {
+      bool is_suspicious_by_default = IsActionSuspiciousByDefault(action);
+      SetActionSuspicious(
+        extension_id,
+        action,
+        is_suspicious_by_default
+      );
+      callback.Run(is_suspicious_by_default);
+    }
+}
+
+bool SuspiciousActionConfig::IsActionSuspiciousByDefault(SuspiciousExtensionAction action) {
+  switch (action) {
+    case SuspiciousExtensionAction::EVENT:
+    case SuspiciousExtensionAction::NETWORK_REQUEST:
+    case SuspiciousExtensionAction::DOM_MUTATION:
+    case SuspiciousExtensionAction::ELEMENT_DESCRIPTION_MUTATION:
+      return true;
+    case SuspiciousExtensionAction::READ_ELEMENT:
+    case SuspiciousExtensionAction::ELEMENT_MUTATION:
+    case SuspiciousExtensionAction::CREATE_ELEMENT:
+    case SuspiciousExtensionAction::NETWORK_RESPONSE:
+    case SuspiciousExtensionAction::NAVIGATOR:
+    default:
+      return false;
+  }
+}
+
+const char* SuspiciousActionConfig::ExtensionActionToString(SuspiciousExtensionAction action) {
+  switch (action) {
+    case SuspiciousExtensionAction::EVENT:
+      return kPromptEvent;
+    case SuspiciousExtensionAction::NETWORK_REQUEST:
+      return kPromptNetworkRequest;
+    case SuspiciousExtensionAction::DOM_MUTATION:
+      return kPromptDomMutation;
+    case SuspiciousExtensionAction::ELEMENT_DESCRIPTION_MUTATION:
+      return kPromptElementDescriptionMutation;
+    case SuspiciousExtensionAction::READ_ELEMENT:
+      return kPromptReadElement;
+    case SuspiciousExtensionAction::ELEMENT_MUTATION:
+      return kPromptElementMutation;
+    case SuspiciousExtensionAction::CREATE_ELEMENT:
+      return kPromptCreateElement;
+    case SuspiciousExtensionAction::NETWORK_RESPONSE:
+      return kPromptNetworkResponse;
+    default:
+      return nullptr;
+  }
+}
